#include <termios.h>

int kbhit(void) {
  struct termios kb_term, kb_oterm;
  int kb_fd = 0;
  int kb_c = 0;
  tcgetattr(kb_fd,&kb_oterm);
  memcpy(&kb_term,&kb_oterm,sizeof(kb_term));
  kb_term.c_lflag = kb_term.c_lflag & (!ICANON);
  kb_term.c_cc[VMIN] = 0;
  kb_term.c_cc[VTIME] = 1;
  tcsetattr(kb_fd,TCSANOW,&kb_term);
  kb_c = getchar();
  tcsetattr(kb_fd,TCSANOW,&kb_oterm);
  if(kb_c != -1)
  ungetc(kb_c,stdin);
  return((kb_c != -1) ? 1 : 0);
}

int getch(void) {
  static int get_ch = -1, get_fd = 0;
  struct termios get_neu,get_alt;
  get_fd = fileno(stdin);
  tcgetattr(get_fd,&get_alt);
  get_neu = get_alt;
  get_neu.c_lflag &= ~(ICANON|ECHO);
  tcsetattr(get_fd,TCSANOW,&get_neu);
  get_ch = getchar();
  tcsetattr(get_fd,TCSANOW,&get_alt);
  return get_ch;
}