
// Globale Header //
//****************//
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <sched.h>

// Lokale Header //
//***************//
#include "lconio.h" 		// Fr kbhit() und getch()
#include "COM.h"
#include "DSL.h"			// DSL Protokoll-Auswertung
#include "SIGNAL.h"

// Globale Variablen //
//*******************//
int fd = 0;

// Funktions Definitionen //
//************************//
void signal_handler_IO(int);
//int open_port(void);
//int create_signal_handler(void);


// Funktionen //
//************//
int main(void) {
  // Variablen
  ////////////
  char cKb = 0;
  int i;
  struct sched_param sched;

  // Echtzeitfaehig machen
  sched.sched_priority = 49;
  
  // Initialisierungen
  ////////////////////
  open_port(&fd);
  create_signal_handler();
 // DSL_init();
  
  // Signalhandler installieren
  /////////////////////////////
  fcntl(fd, F_SETOWN, getpid());
  fcntl(fd, F_SETFL, FASYNC);
  
  do {
  
    switch(DSL_Header) {
      case 0x1F: printf("\n"); for(i=0;i<7;i++) { /*DSL_write(hSerial,&DSL_outArray[0][i]);*/ printf("%3i ",DSL_inArray[0][i]); }; DSL_Header = 0; break;
      case 0x10: for(i=0;i<6;i++) { /*DSL_write(hSerial,&DSL_outArray[1][i]);*/ printf("%3i ",DSL_outArray[1][i]); }; DSL_Header = 0; break;
      case 0x12: for(i=0;i<6;i++) { /*DSL_write(hSerial,&DSL_outArray[2][i]);*/ printf("%3i ",DSL_outArray[2][i]); }; DSL_Header = 0; break;
      case 0x14: for(i=0;i<6;i++) { /*DSL_write(hSerial,&DSL_outArray[3][i]);*/ printf("%3i ",DSL_outArray[3][i]); }; DSL_Header = 0; break;
      case 0x16: for(i=0;i<6;i++) { /*DSL_write(hSerial,&DSL_outArray[4][i]);*/ printf("%3i ",DSL_outArray[4][i]); }; DSL_Header = 0; break;
      case 0x18: for(i=0;i<6;i++) { /*DSL_write(hSerial,&DSL_outArray[5][i]);*/ printf("%3i ",DSL_outArray[5][i]); }; DSL_Header = 0; break;
      default: break;
    }
     
//	unsigned char Byte;
//	read(fd,&Byte,1);
//    DSL_fill_inArray(Byte);
//    DSL_fill_outArray();
  
    if(kbhit()) {
      cKb = getch();
    }
  } while(cKb != 27);
 
  close(fd);
  printf("\n");
  
  return 1;
}


void signal_handler_IO(int status) {
//  pthread_t DSL_thread;
  unsigned char read_fd=0, Byte=0;
  read_fd = read(fd,&Byte,sizeof(Byte));
//  pthread_create(&DSL_thread,NULL,DSL_data_incoming,Byte);
//  pthread_join(DSL_thread,NULL);
  DSL_fill_inArray(Byte);
  //tcflush(fd, TCIFLUSH);
}
