#ifndef COM_H
#define COM_H

// Globale Header //
//****************//
#include <stdio.h>
#include <termios.h>
#include <fcntl.h>
#include <errno.h>

int open_port(int *fd) {
	struct termios port;

	*fd = open("/dev/ttyUSB0", O_RDWR | O_NOCTTY | O_NDELAY | O_NONBLOCK);
              
	if ( *fd == -1 ) {
		printf("fd: %d\n",*fd);
		perror("open_port: Unable to open /dev/ttyUSB0. ");
		return 0;
	}
 
	// Port Einstellungen
//	cfsetispeed(&port, B38400);
//	cfsetospeed(&port, B38400);
	port.c_cflag = B38400 | CS8 | CLOCAL | CREAD | HUPCL;
	port.c_iflag = IGNPAR | IGNBRK;
	port.c_iflag = 0;
	port.c_lflag = 0;
	tcflush(*fd, TCIFLUSH);
	tcsetattr(*fd,TCSANOW,&port); 

	printf("new cflag=%08x\n", port.c_cflag);
    printf("new oflag=%08x\n", port.c_oflag);
    printf("new iflag=%08x\n", port.c_iflag);
    printf("new lflag=%08x\n", port.c_lflag);
    printf("new line=%02x\n", port.c_line);

	return 1;

}

#endif